Program KMP;

Const nMax = 255;
      mMax = 255;

Var Urm: Array[1..mMax] Of Byte;
    T, P: String;
    n, m, q, i: Byte;
    f, g: Text;
    Comp: Word;

Procedure Urmatorul(P: String);
Var k, m, q: Byte;
Begin
  m := Length(P);
  Urm[1] := 0;
  k := 0;
  For q := 2 To m Do  {determina lungimea celui mai lung prefix al lui P
                       care este si sufix al subsirului Pq (P[1..q]) }
    Begin
      While (k>0) And (P[k+1]<>P[q]) Do
        Begin
          k := Urm[k];
          Inc(Comp)
        End;
      If P[k+1]=P[q] Then
        Begin
          Inc(k);
          Inc(Comp)
        End;
      Urm[q] := k
    End
End;

Begin
  Assign(f, 'KMP.IN'); Reset(f);
  Assign(g, 'KMP.OUT'); ReWrite(g);
  ReadLn(f, T);
  ReadLn(f, P);
  Comp := 0;
  n := Length(T);
  m := Length(P);
  Urmatorul(P);
  q := 0;
  For i := 1 To n Do
    Begin
      While (q>0) And (P[q+1]<>T[i]) Do
        Begin
          q := Urm[q];
          Inc(Comp)
        End;
      If P[q+1]=T[i] Then
        Inc(q); {s-au potrivit}
      Inc(Comp);
      If q=m Then
        Begin
          WriteLn(g, 'Am gasit subsirul in pozitia ', i-m+1);
          q := Urm[q]
        End;
      Inc(Comp);
    End;
  WriteLn(g, 'Am facut ', Comp, ' comparatii');
  Close(g)
End.
