#include <stdio.h>
#include <vector>
#include <map>

#define KMAX 6
#define SMAX (1*2*3*4*5*6 * (1 << (KMAX + 1)))
#define MOD 30103

using namespace std;

vector<int> A[SMAX]; /* adiacenta */

map<vector<int>, int> SMAP;
vector<int> ST[SMAX];

int D[2][SMAX];
int N, K, S, M;

int stack[KMAX+1];

void perm(int niv)
{
        int i, j;

        if (niv == K + 1)
        {
                for (i = 0; i < (1 << (K+1)); i++)
                {
                        for (j = 0; j < K; j++)
                        {
                                if ((i >> j) & 1)
                                   ST[S].push_back(0);
                                ST[S].push_back(stack[j+1]);
                        }
                        if ((i >> j) & 1)
                           ST[S].push_back(0);
                        S++;
                }
        } else
        {
                for (i = 1; i <= K; i++)
                {
                        stack[niv] = i;
                        for (j = 1; j < niv; j++)
                            if (stack[j] == i)
                            {
                             stack[niv] = 0;
                             break;
                            }
                        if (stack[niv])
                           perm(niv+1);
                }
        }
}

void compute_graph()
{
        int i, j, p, ns;
        vector<int> temp;
        vector<int>::iterator it;
        
        perm(1);
        for (i = 0; i < S; i++)
            SMAP[ST[i]] = i;
        for (i = 0; i < S; i++)
        {
                for (p = 0; p <= ST[i].size(); p++)
                    if ((p == 0 || ST[i][p-1] != 0) && (p == ST[i].size() || ST[i][p] != 0))
                    {
                        temp.clear();
                        for (j = 0; j < p; j++)
                            temp.push_back(ST[i][j]);
                        temp.push_back(K+1);
                        for (; j < ST[i].size(); j++)
                            temp.push_back(ST[i][j]);
                        for (j = 0; j < temp.size(); j++)
                            if (temp[j] > 0)
                               temp[j]--;
                        for (it = temp.begin()+1, j = 1; j < temp.size(); j++, it++)
                            if (temp[j] == 0 && temp[j-1] == 0)
                            {
                               temp.erase(it);
                               it--;
                               j--;
                            }
                        ns = SMAP[temp];
                        if (ns == 0) {
                           printf("NS should never exist!!!");
                           exit(1);
                        }
                        
                        A[i].push_back(ns);
                        M++;
                    }
        }
}

int main()
{
        int i, j, s, d, t;

        freopen("cabane.in", "r", stdin);
        freopen("cabane.out", "w", stdout);
        scanf("%d%d", &N, &K);
        compute_graph();

/*        for (i = 0; i < S; i++)
        {
                printf("   %d: ", i);
                for (j = 0; j < ST[i].size(); j++)
                    printf("%d ", ST[i][j]);
                printf("        ");
                for (j = 0; j < A[i].size(); j++)
                    printf("%d ", A[i][j]);
                printf("\n");
        }
*/

        s = 0, d = 1;
        for (i = 0; i < S; i++)
            if (ST[i].size() == K)
                    D[s][i] = 1;
        
        for (t = K+1; t <= N; t++)
        {
                for (i = 0; i < S; i++)
                    D[d][i] = 0;
                for (i = 0; i < S; i++)
                    for (j = 0; j < A[i].size(); j++)
                        D[d][ A[i][j] ] = (D[d][ A[i][j] ] + D[s][i]) % MOD;

                s ^= 1;
                d ^= 1;
        }

        t = 0;
        for (i = 0; i < S; i++)
            t = (t + D[s][i]) % MOD;
        printf("%d\n", t);

        return 0;
}

