#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define NMAX 300

#define proc 0.33
#define RANGE 1000
#define PRANGE 960
#define PRANGE2 0
#define NN 256

int nstart[30] = 
{
	4,
	5,
	1,
	5,
	4,
	1,
	1,
	1,
	4,
	6,
	7,
	4,
	1,
	5,
	8,
	5,
	6,
	5,
	1,
	1,

	1,
	1,
	1,
	1
};

int conexx[30] = 
{
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	1,
	0,
	0,
	0,
	0,
	0
};

int A[NMAX][NMAX], viz[NMAX], p[NMAX], used[NMAX], deg[NMAX], tata[NMAX];
int i, j, k, N, M, T;

void df(int nod)
{
	int i;

	viz[nod] = 1;

	for (i = 1; i <= N; i++)
		if (A[nod][i] && !viz[i])
			df(i);
}

int conex(void)
{
	int i;

	memset(viz, 0, sizeof(viz));
	df(1);

	for (i = 1; i <= N; i++)
		if (!viz[i])
			return 0;
	
	return 1;
}

int main()
{
	int t;

	freopen("tj.in", "w", stdout);

	T = 20;
	N = NN;

	printf("%d\n", T);

	srand(time(NULL));
	for (t = 0; t < T; t++)
	{
		nstart[t] = rand() % 2;

		if (nstart[t] == 0)
		{
			nstart[t] = 1;
			fprintf(stderr, "*");
		}
		else
			nstart[t] += 4 + rand() % 4;

		do
		{
			memset(A, 0, sizeof(A));

			memset(used, 0, sizeof(used));
			for (i = 1; i <= N; i++)
			{
				do
				{
					j = 1 + (rand() % N);
				}
				while (used[j]);

				used[j] = 1;
				p[i] = j;
			}

			memset(deg, 0, sizeof(deg));

			if (nstart[t] > 2)
			{
				for (i = 1; i < nstart[t]; i++)
					A[p[i]][p[i+1]] = A[p[i+1]][p[i]] = 1,
					deg[p[i]]++, deg[p[i+1]]++;

				A[ p[nstart[t]] ][ p[1] ] = A[ p[1] ][ p[nstart[t]] ] = 1,
				deg[ p[nstart[t]] ]++, deg[ p[1] ]++;
			}

			memset(tata, 0, sizeof(tata));
			for (i = nstart[t] + 1; i <= N; i++)
			{
				j = p[1 + (int)(proc * (rand() % (i - 1)))];
				
				for (k = 1; k <= N; k++)
					if (k != tata[j] && A[j][k] && ((rand() % RANGE) < PRANGE))
						A[p[i]][k] = A[k][p[i]] = 1;

				A[j][p[i]] = A[p[i]][j] = 1;
				tata[p[i]] = j;

				if (rand() % PRANGE < PRANGE2)
				{
					k = tata[tata[p[i]]];
					while (k)
					{
						A[k][p[i]] = A[p[i]][k] = 1;
						k = tata[k];
					}
				}
			}
		}
		while (conexx[t] && !conex());

		M = 0;
		for (i = 1; i < N; i++)
			for (j = i + 1; j <= N; j++)
				if (A[i][j])
					M++;

		printf("%d %d\n", N, M);
		fprintf(stderr, "%d : %d %d\n", t + 1, N, M);

		for (i = 1; i < N; i++)
			for (j = i + 1; j <= N; j++)
				if (A[i][j])
					printf("%d %d\n", i, j);

		printf("\n");
	}
	
	return 0;
}