Program KMP;

Const nMax = 255;
      mMax = 255;

Var Urm: Array[1..mMax] Of Byte;
    T, P: String;
    n, m, q, i, l: Byte;
    f, g: Text;
    Comp: Word;

Procedure Urmatorul(P: String);
Var k, m, q: Byte;
Begin
  m := Length(P);
  Urm[1] := 0;
  k := 0;
  For q := 2 To m Do  {determina lungimea celui mai lung prefix al lui P
                       care este si sufix al subsirului P[1..q] }
    Begin
      While (k>0) And (P[k+1]<>P[q]) Do
        Begin
          k := Urm[k];
          Inc(Comp)
        End;
      If P[k+1]=P[q] Then
          Inc(k);
      Inc(Comp);
      Urm[q] := k
    End
End;

Begin
  Assign(f, 'KMPFIS.PAS'); Reset(f);
  Assign(g, 'KMPFIS.OUT'); ReWrite(g);
  Write('Model = '); ReadLn(P);
  Comp := 0;
  m := Length(P);
  Urmatorul(P);
  While Not Eof(f) Do
  Begin
    ReadLn(f, T);
    n := Length(T);
    Inc(l);
    q := 0;
    For i := 1 To n Do
      Begin
        While (q>0) And (P[q+1]<>T[i]) Do
          Begin
            q := Urm[q];
            Inc(Comp)
          End;
        If P[q+1]=T[i] Then
            Inc(q); {s-au potrivit}
        Inc(Comp);
        If q=m Then
          Begin
            WriteLn(g, 'Am gasit subsirul in linia ', l, ' pozitia ', i-m+1);
            q := Urm[q]
          End;
      End;
  End;
  WriteLn(g, 'Am facut ', Comp, ' comparatii');
  Close(g)
End.