#include <stdio.h>
#include <string.h>
#include <algorithm>

#define PMAX 100
#define NMAX PMAX
#define fwd 2
#define baza 10
#define fmt "%1d"

typedef int BigNum[100];

using namespace std;

int p[PMAX], np, N;
int d[PMAX], nd;

struct lcmp {
	bool operator()(const int &a, const int &b) const {
		return a>b;
	}
};

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
int compare(BigNum n1, BigNum n2) {
    int i, res;
    if (n1[0] > n2[0]) return 1;
    if (n1[0] < n2[0]) return -1;
    for (res = 0, i = n1[0]; i >= 1; i--)
        if (n1[i] > n2[i]) {
           res=1; break;
        }
        else
        if (n1[i] < n2[i]) {
           res=-1; break;
        }

        return res;
}

void mult(int x, BigNum num, BigNum rez) {

        int i, ndigits = num[0];

        memset(rez, 0, sizeof(BigNum));
        for (i = 1; i <= ndigits; i++) rez[i] = num[i]*x;
        for (i = 1; i <= (ndigits+fwd); i++) if (rez[i] >= baza) {
            rez[i+1] += (rez[i]/baza); rez[i] %= baza;
        }
        for (i = (ndigits+fwd); i >= 1; i--) if (rez[i] > 0) {
            rez[0] = i; break;
        }
}

int stg[PMAX];
int stm[PMAX], nt;
int vg[PMAX];

BigNum best;

void back(int niv)
{
        int i;
        
        if (niv == nd) {
           BigNum temp, t1;
           int ok;
        
           for (i = 0; i <= stm[niv-1]; i++)
               vg[i] = 1;
           for (i = 0; i < niv; i++)
               vg[ stg[i] ] *= d[i];
           sort(&vg[0], &vg[stm[niv-1] + 1], lcmp());

/*           printf("       ");
           for (i = 0; i <= stm[niv-1]; i++)
               printf("%d ", vg[i]);
           printf("\n");
           nt++;
*/
                memset(temp, 0, sizeof(BigNum));
                temp[0] = temp[1] = 1;
                ok = 1;
                for (i = 0; ok && i <= stm[niv-1]; i++)
                    while (vg[i] > 1) {
                          vg[i]--;
                          mult(p[i+1], temp, t1);
                          memcpy(temp, t1, sizeof(BigNum));
                          if (compare(temp, best) == 1) {
                             ok = 0;
                             break;
                          }
                    }
                    
                if (ok)
                   memcpy(best, temp, sizeof(BigNum));

        } else
        {
                stm[niv] = stm[niv-1]+1;
                stg[niv] = stm[niv-1]+1;
                back(niv+1);
                for (i = 0; i <= stm[niv-1]; i++)
                {
                        stm[niv] = stm[niv-1];
                        stg[niv] = i;
                        back(niv+1);
                }
        }
}

int main()
{
 int i, j, ok;
 best[0] = NMAX;

 freopen("trapez.in", "r", stdin);
 freopen("trapez.out", "w", stdout);
 scanf("%d", &N);
 p[0] = 2;
 np = 1;
 for (i = 3; i <= PMAX; i+=2)
 {
     ok = 1;
     for (j = 1; j < np && p[j] * p[j] <= i; j++)
         if (i % p[j] == 0)
         {
                ok = 0;
                break;
         }
     if (ok)
        p[np++] = i;
 }

 for (i = 0; i < np; i++)
     while (N % p[i] == 0)
     {
        d[nd++] = p[i];
        N /= p[i];
     }

 stg[0] = 0;
 stm[0] = 0;
 back(1);

 printf("%d", best[ best[0] ]);
 for (i = best[0] - 1; i > 0; i--)
     printf(fmt, best[i]);
 printf("\n");

 return 0;
}
