#include <stdio.h>
#include <stdlib.h>
#define InFile "traseu.in"
#define OutFile "traseu.out"
#define NMax 1000

int n, m, c[NMax], nr[NMax], t[NMax], lg, sum, pus[NMax], sc;
int g[NMax][NMax], d[NMax][NMax], niv[NMax][NMax], nrniv;
int lgmin=NMax+1, tmin[NMax];

void citire(void);
void add(int, int);
void niveluri(void);
void constr_d(void);
void constr_traseu(int);
void gen_bkt(int);
void afisare(void);

int main()
{
int i, s;
citire();
niveluri();
constr_d();
for (i=1; i<=n; i++)
    if (niv[nrniv][i])
       {lg=0; sc=0;
        for (s=1; s<=n; s++) pus[s]=0;
        constr_traseu(i);
        gen_bkt(lg+1);
       }
afisare();
return 0;
}

void citire()
{int i, ok, x, y;
FILE * fin=fopen(InFile,"r");
fscanf(fin,"%d%d",&n, &m);
for (i=1; i<=n; i++)
    {ok=fscanf(fin,"%d",c+i);
     if (ok!=1) printf("credite incorecte\n");
     if (c[i]<1 || c[i]>20) printf("credite incorecte\n");
     }
do
  {ok=fscanf(fin,"%d%d",&x, &y);
   if (ok==2)
       {
       if (x>n || y>n) printf("vf incorecte\n");
       add(x,y);
       }
   }
while (ok==2);
fclose(fin);          }

void add(int x, int y)
//y depinde de x
{
if (g[x][y]) printf("arcul %d %d se repeta\n",x, y);
nr[y]++;  g[x][y]=d[x][y]=1; }

void niveluri()
{
int x=0, gasit=1, i, j;
while (x<n && gasit)
      {
      gasit=0;   nrniv++;
      for (i=1; i<=n; i++)
          if (nr[i]==0)
             {niv[nrniv][i]=1; x++;
              gasit=1;}
      for (i=1; i<=n; i++)
          if (niv[nrniv][i])
             {nr[i]=-1;
              for (j=1; j<=n; j++)
                  if (g[i][j]) nr[j]--;
              }
      }
if (x<n) printf("Gresit! Graful contine circuite!\n");
}

void constr_d()
{
int i,j,k;
for (i=1; i<=n; i++) d[i][i]=1;
for (k=1; k<=n; k++)
    for (i=1; i<=n; i++)
        for (j=1; j<=n; j++)
            if (d[i][j]<d[i][k]*d[k][j])
               d[i][j]=1;
}

void gen_bkt(int k)
{
int i, j, ok;
if (k-1>=lgmin) return;
if (sc==m)
   {lgmin=k-1;
   for (j=1; j<k; j++) tmin[j]=t[j];}
else
for (i=1; i<=n; i++)
    if (!pus[i] && sc+c[i]<=m)
       {
        ok=1;
        //verific daca toate cursurile de care depinde i sunt puse
        for (j=1; j<=n && ok; j++)
             if (i!=j)
                if (d[j][i] && !pus[j]) ok=0;
        if (ok)
           {t[k]=i;
            pus[i]=1; sc+=c[i];
            gen_bkt(k+1);
            pus[i]=0; sc-=c[i];       }
       }
}

void constr_traseu(int x)
{int i, j;
for (i=1; i<=nrniv; i++)
    for (j=1; j<=n; j++)
        if (niv[i][j] && d[j][x])
           {lg++; t[lg]=j;  sc+=c[j]; pus[j]=1;}
}


void afisare()
{
int i;
FILE * fout=fopen(OutFile,"w");
if (lgmin==NMax+1) {
   printf("Nu exista solutie \n");
   return;}
fprintf(fout,"%d\n", lgmin);
for (i=1; i<lgmin; i++)
    fprintf(fout,"%d ",tmin[i]);
fprintf(fout,"%d\n",tmin[lgmin]);
fclose(fout);
}