#include <stdio.h>

#include <vector>
#define INF 666666
#define NMAX 1000

using namespace std;

int N, TC, NIVM, sel;
int C[NMAX], niv[NMAX], viz[NMAX], st[NMAX], sol[NMAX], o[NMAX];
int NC, NP, bestNP = INF, solVF;

int vf_sel[NMAX][NMAX];
int nvf_sel[NMAX];
int nsel;

vector<int> v[NMAX];

void df(int vf)
{
    unsigned int i;

    if (viz[vf] == 1)
       return;
    if (viz[vf] == 2)
    {
       printf("Graf ciclic!!!\n");
       return;
    }
    
    viz[vf] = 2;
    niv[vf] = 0;
    for (i = 0; i < v[vf].size(); i++)
    {
        df(v[vf][i]);
        niv[vf] = max(niv[vf], niv[v[vf][i]]+1);
    }
    viz[vf] = 1;
}

void mark(int vf)
{
    unsigned int i;

    if (viz[vf])
       return;
    viz[vf] = 1;
    vf_sel[nsel][nvf_sel[nsel]++] = vf;
    NC += C[vf];
    NP++;

    for (i = 0; i < v[vf].size(); i++)
        mark(v[vf][i]);
}

void add_selection(int vf)
{
        nvf_sel[nsel] = 0;
        mark(vf);
        nsel++;
}

void remove_selection()
{
    int i;
    nsel--;
    for (i = 0; i < nvf_sel[nsel]; i++)
    {
        NP--;
        NC -= C[vf_sel[nsel][i]];
        viz[vf_sel[nsel][i]] = 0;
    }

}

void back(int nivel)
{
    int i, vf;

    if (NC > TC)
       return;

    if (NC == TC && NP < bestNP)
    {
        memcpy(sol, st, (nivel+1) * sizeof(int));
        sol[0] = sel;
        bestNP = NP;
        solVF = nivel;
    } else
    {
        for (i = st[nivel-1] + 1; i <= N; i++)
            if ((!viz[o[i]]) && ((niv[o[i]] < NIVM) || ( o[i] > sel )))
            {
                vf = o[i];
                st[nivel] = i;
                add_selection(vf);
                back(nivel+1);
                remove_selection();
            }
    }

}

void printit(int vf)
{
  unsigned int i;

  if (viz[vf])
     return;
  viz[vf] = 1;
  
  for (i = 0; i < v[vf].size(); i++)
  {
    printit(v[vf][i]);
  }
 printf("%d ", vf);
}

int main()
{
	int i, j, l1, l2;
	freopen("traseu.in", "r", stdin);

	scanf("%d%d", &N, &TC);
	for (i = 1; i <= N; i++)
		scanf("%d", C + i);

	while (scanf("%d%d", &l1, &l2) == 2)
		v[l2].push_back(l1);

	memset(viz, 0, sizeof(viz));
	for (i = 1; i <= N; i++)
			df(i);
	for (i = 1; i <= N; i++)
	{
		NIVM = max(NIVM, niv[i]);
	}

    for (i = 1; i <= N; i++)
        o[i] = i;
    for (i = 1; i < N; i++)
        for (j = i+1; j <= N; j++)
            if (niv[o[i]] < niv[o[j]])
               swap(o[i], o[j]);

	memset(viz, 0, sizeof(viz));
	for (sel = 1; sel <= N; sel++)
        if (niv[sel] == NIVM)
        {
            fprintf(stderr, "%d\n", sel);
            add_selection(sel);
            back(1);
            remove_selection();
        }

	memset(viz, 0, sizeof(viz));
	printf("%d\n", bestNP);
    printit(sol[0]);
	for (i = 1; i < solVF; i++)
        printit(o[sol[i]]);
	printf("\n");
	
	return 0;
}

